//
// extended version Paul Janson & Rob Golsteijn
//
// 2006-08-30 import and continue on the games
// 2006-08-31 import from difficulty to sudoku pref
//            switch of sound
//            ordered hints
//            auto hints
//            ....todo
//2006-09-01  show uniques
//            promote unique
//            export puzzle
//            save status/game
//2006-09-04  update show unique  (include values given and user values)
//            load status/game
//            if delete value & autohints_ => DO IT
//            remove hints
//            updated focus event
//            show this value '?' 
//            remove colors ' '
//2006-09-05  backtrack possible solutions
//2006-09-06  refined backtracking
//            standalone project with makefile 
//         
// DONE/TODO:
// V toggle for sound off ;^) speeds up animations to ;^)
// V move imported from difficulty to its own preference/bool/int "imported_"
// V export puzzel <files?>
// V save work (puzzel, plus choizen, plus hints)
// V load work (if 1 row only the puzzle ;^)
// V keep hints at a fixed place 123,456,789 for easy overview
// V generate hints (for all empty places) using row column and box
// V (open cell) generate hints (for THIS cell) [row, col,box] <who is this i,j>
// V (value cell) update hints from this cell value [row,col,box]
// V auto update hints on value setting
// V highlght unique in row/col/box  (auto highlight function)
// V promote unique hint to value
// V auto unique & promote
// V if delete value & autohints_ => DO IT show hints for this cell again
// V remove hints (kind of restart without removing the USER values
// ? what about resetting test_values when entering a value, keep as rollback, and not draw for user value?
     //maybe outdated idea, because of autohint update when '0' or delete.
// - radiobuttons none when imported???
// - ?? if promote do a unique??
// V highlight all with this value (temporary) MAGENTA
// v When to remove color of unique hints (cyan backgrounds) & black hints??? => SPACEBAR
// v When to remove color of this value   (magenta backgrounds) ??? => SPACEBAR
// - log automatic actions (unique in row, promote,...).
// - FAMOUS LAST : solve really
// -> generate real sudoku(only 1 solution)
//    find as many solutions as possible by backtracking? or solve internally first to check for one unique solution.
// V check how many solutions (backtracking) 
//   - store solution if import / hassolution_ is false [option]
// = useful UI namesd and shortcuts
// - UI stuf grayout if option unavailable
// - Help me : computer give a HINT (if hassolution) - random on open fields highlight it?-.
// X print to printer (no FLTK support)
// - print to file puzzle / game

// - promote user value to puzzle value (readonly) to make a unique puzzle:)
//
// "$Id: sudoku.cxx 4744 2006-01-13 22:46:30Z mike $"
// Sudoku game using the Fast Light Tool Kit (FLTK).
//
// Copyright 2005-2006 by Michael Sweet.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//
// Please report all bugs and problems on the following page:
//
//     http://www.fltk.org/str.php
//
#include <FL/Fl.H>
#include <FL/Enumerations.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Group.H>
#include <FL/fl_ask.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Help_Dialog.H>
#include <FL/Fl_Preferences.H>
#include <FL/Fl_Sys_Menu_Bar.H>
#include <FL/x.H>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <FL/math.h>

/*
char* names[] = {	// events
"FL_NO_EVENT",
"FL_PUSH",
"FL_RELEASE",
"FL_ENTER",
"FL_LEAVE",
"FL_DRAG",
"FL_FOCUS",
"FL_UNFOCUS",
"FL_KEYDOWN",
"FL_KEYUP",
"FL_CLOSE",
"FL_MOVE",
"FL_SHORTCUT",
"FL_DEACTIVATE",
"FL_ACTIVATE",
"FL_HIDE",
"FL_SHOW",
"FL_PASTE",
"FL_SELECTIONCLEAR",
"FL_MOUSEWHEEL",
"FL_DND_ENTER",
"FL_DND_DRAG",
"FL_DND_LEAVE",
"FL_DND_RELEASE"
};
*/

#ifdef WIN32
#  include "sudokurc.h"
#elif !defined(__APPLE__)
//#  include "sudoku.xbm"
#endif // WIN32

// Audio headers...
#include <config.h>

#ifndef WIN32
#  include <unistd.h>
#endif // !WIN32

#ifdef HAVE_ALSA_ASOUNDLIB_H
#  define ALSA_PCM_NEW_HW_PARAMS_API
#  include <alsa/asoundlib.h>
#endif // HAVE_ALSA_ASOUNDLIB_H
#ifdef __APPLE__
#  include <CoreAudio/AudioHardware.h>
#endif // __APPLE__
#ifdef WIN32
#  include <mmsystem.h>
#endif // WIN32

//PLJ file IO
#include <iostream>
#include <fstream>
using namespace std;
#include <FL/Fl_File_Chooser.H>
#include <cstring>

//version numbers
#define VERSION	"1"
#define BUILD	"9"

#define DUMMY	0

/*
//Default sizes...
*/
#define GROUP_SIZE	160
#define CELL_SIZE	50
#define CELL_OFFSET	5
#ifdef __APPLE__
#  define MENU_OFFSET	0
#else
#  define MENU_OFFSET	25
#endif // __APPLE__

// Sound class for Sudoku...
//
// There are MANY ways to implement sound in a FLTK application.
// The approach we are using here is to conditionally compile OS-
// specific code into the application - CoreAudio for MacOS X, the
// standard Win32 API stuff for Windows, ALSA or X11 for Linux, and
// X11 for all others.  We have to support ALSA on Linux because the
// current Xorg releases no longer support XBell() or the PC speaker.
//
// There are several good cross-platform audio libraries we could also
// use, such as OpenAL, PortAudio, and SDL, however they were not chosen
// for this application because of our limited use of sound.
//
// Many thanks to Ian MacArthur who provided sample code that led to
// the CoreAudio implementation you see here!
class SudokuSound {
  // Private, OS-specific data...
#ifdef __APPLE__
  AudioDeviceID device;
  AudioStreamBasicDescription format;
  short *data;
  int remaining;

  static OSStatus audio_cb(AudioDeviceID device,
			   const AudioTimeStamp *current_time,
			   const AudioBufferList *data_in,
			   const AudioTimeStamp *time_in,
			   AudioBufferList *data_out,
			   const AudioTimeStamp *time_out,
			   void *client_data);
#elif defined(WIN32)
  HWAVEOUT	device;
  HGLOBAL	header_handle;
  LPWAVEHDR	header_ptr;
  HGLOBAL	data_handle;
  LPSTR		data_ptr;

#else
#  ifdef HAVE_ALSA_ASOUNDLIB_H
  snd_pcm_t *handle;
#  endif // HAVE_ALSA_ASOUNDLIB_H
#endif // __APPLE__

  // Common data...
  static int frequencies[9];
  static short *sample_data[9];
  static int sample_size;
  int soundon_;
  public:

  SudokuSound();
  ~SudokuSound();

  void	play(char note);
  void	soundon(int on); //1 is on 
};


// Sudoku cell class...
class SudokuCell : public Fl_Widget {
  bool		readonly_;
  int		value_;
  int		hints_[9+1]; //PLJ improved for all values on fixed place
  int       uniquehint_;
  
  public:

		SudokuCell(int X, int Y, int W, int H);
  void		draw();
  int		handle(int event);
  void		readonlySet(bool r) { readonly_ = r; redraw(); }
  bool		readonlyGet() const { return readonly_; }
  void		test_valueSet(int v, int n) { hints_[v] = v; redraw(); }
  void		hintsRemove(int v) { hints_[v] = 0; redraw(); }
  int		hintsGet(int n) const { return hints_[n]; }
 
  void		valueSet(int v)
            {
		      value_ = v;
              for (int i = 0; i <= 9; i ++) hints_[i] = 0;
		      redraw();
		    }
  int		valueGet() const { return value_; }
  void		init(int x, int y);//plj remember own position in the grid in myI, myJ
  int       myI, myJ;  //to remember its own place in the grid for focus feedback
  void      uniquehintSet(int v)
            {
              uniquehint_ = v;
            }
  int       uniquehintGet(){ return uniquehint_;}            
  void      resetHints() 
            { 
            	for (int i = 0; i <= 9; i ++) hints_[i] = 0; 
            	uniquehint_ = 0;
            }

};

// Sudoku window class...
class Sudoku : public Fl_Window {
  Fl_Sys_Menu_Bar *menubar_;
  Fl_Group	*grid_;
  time_t	seed_;
  char		grid_values_[9][9];
  SudokuCell	*grid_cells_[9][9];
  Fl_Group	*grid_groups_[3][3];
  int		difficulty_;  //0,.3;  4= imported!
  //PLJ
  int hassound_; //1 = sound; 0 sound is off
  int autohints_; //1 = on; 0 is off
  int hassolution_; //1 has solution (original difficulty); 0= imported files
  int autounique_; //1 = on; 0 is off
  int promoteunique_; //1=0 0 is off
  char cellHint[9][9];  //keep single hint of cell
  char testGrid[9][9][11];  // i j values; [0] the actual value, [1.9] hints, [10] 1:value/0:hints 
  SudokuSound	*sound_;
  int lastFocusI, lastFocusJ;
  long solvechecks;
  int solutionsStopped;

  static void	check_cb(Fl_Widget *widget, void *);
  static void	close_cb(Fl_Widget *widget, void *);
  static void	diff_cb(Fl_Widget *widget, void *d);
  static void	help_cb(Fl_Widget *, void *);
  static void	new_cb(Fl_Widget *widget, void *);
  static void	cell_callback(Fl_Widget *widget, void *);
  static void	restart_cb(Fl_Widget *widget, void *);
         void	set_title();
  static void	showSolution_cb(Fl_Widget *widget, void *);

  static Fl_Help_Dialog *help_dialog_;
  static Fl_Preferences	prefs_;
  
  //PLJ:
  static void	input_cb(Fl_Widget *widget, void *); //(import a string todo a file)
  static void   doit_cb( Fl_Widget* , void* );  //function prototypes
  static void	savepuzzle_cb(Fl_Widget *widget, void *);
  static void	savegame_cb(Fl_Widget *widget, void *);
  static void	loadgame_cb(Fl_Widget *widget, void *);
  static void	hassound_cb(Fl_Widget *widget, void *);
  static void	autohints_cb(Fl_Widget *widget, void *);
  static void	hints_cb(Fl_Widget *widget, void *);
  static void	hintthis_cb(Fl_Widget *widget, void *);
  static void	updatehintsfromthis_cb(Fl_Widget *widget, void *);
  static void	showuniquehints_cb(Fl_Widget *widget, void *);
  static void	autounique_cb(Fl_Widget *widget, void *);
  static void	promoteunique_cb(Fl_Widget *widget, void *);
  static void	autopromoteunique_cb(Fl_Widget *widget, void *);
  static void	removehints_cb(Fl_Widget *widget, void *);
  static void	showthisvalue_cb(Fl_Widget *widget, void *);
  static void	helpme_cb(Fl_Widget *widget, void *);
  static void	NumberOfSolutions_cb(Fl_Widget *widget, void *);
  
  bool import_stopped; //import string walker guard
  //bool teller; //import string walker
  
  public:
  	Sudoku();
	~Sudoku();

  void		check_game(bool highlight = true);
  void		load_pref_game();
  void		new_game(time_t seed);
  int		next_value(SudokuCell *c);
  void		resize(int X, int Y, int W, int H);
  void		save_pref_game();
  void		showSolution_game();
  //PLJ:
  void      input_game(char * import);
  int       getNextValue(char* import, int teller);
  void      setFocusCell(int I,int J);
  void      updatehintsfromthis(int i, int j);
  void      hintthiscell(int i, int j);
  int       getautohints();
  void      showuniquehints();
  void      testcell(SudokuCell* cell, int* hints, int index);
  void      printHints(int * hints);
  int       getautounique();
  int       getpromoteunique();
  void      hints();
  void      promoteuniquehints();
  void      removehints();
  void      showthisvalue(int i, int j);
  void	    cleanBackgrounds();
  void      helpme();
  void      numberOfSolutions();
  void      solveGrid(int startValue, int* solutions);
  int       checkGrid();
  void      printGridcell(int printi, int printj);
  void      printGrid();
};


// Sound class globals...
int SudokuSound::frequencies[9] = {
  880,	// A(5)
  988,	// B(5)
  1046,	// C(5)
  1174,	// D(5)
  1318,	// E(5)
  1396,	// F(5)
  1568,	// G(5)
  1760,	// H (A6)
  1976	// I (B6)
};
short *SudokuSound::sample_data[9] = { 0 };
int SudokuSound::sample_size = 0;


// Initialize the SudokuSound class
SudokuSound::SudokuSound() {
  sample_size = 0;
  //PLJ
  soundon_ = 1; //on
	
#ifdef __APPLE__
  remaining = 0;

  UInt32 size = sizeof(device);

  if (AudioHardwareGetProperty(kAudioHardwarePropertyDefaultOutputDevice,
			       &size, (void *)&device) != noErr) return;

  size = sizeof(format);
  if (AudioDeviceGetProperty(device, 0, false, kAudioDevicePropertyStreamFormat,
			     &size, &format) != noErr) return;

  // Set up a format we like...
  format.mSampleRate       = 44100.0;	// 44.1kHz
  format.mChannelsPerFrame = 2;		// stereo

  if (AudioDeviceSetProperty(device, NULL, 0, false,
                             kAudioDevicePropertyStreamFormat,
	                     sizeof(format), &format) != noErr) return;

  // Check we got linear pcm - what to do if we did not ???
  if (format.mFormatID != kAudioFormatLinearPCM) return;

  // Attach the callback
  if (AudioDeviceAddIOProc(device, audio_cb, (void *)this) != noErr) return;

  // Start the device...
  AudioDeviceStart(device, audio_cb);

  sample_size = (int)format.mSampleRate / 20;

#elif defined(WIN32)
  WAVEFORMATEX	format;

  memset(&format, 0, sizeof(format));
  format.cbSize          = sizeof(format);
  format.wFormatTag      = WAVE_FORMAT_PCM;
  format.nChannels       = 2;
  format.nSamplesPerSec  = 44100;
  format.nAvgBytesPerSec = 44100 * 4;
  format.nBlockAlign     = 4;
  format.wBitsPerSample  = 16;

  data_handle = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, format.nSamplesPerSec / 5);
  if (!data_handle) return;

  data_ptr = (LPSTR)GlobalLock(data_handle);

  header_handle = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, sizeof(WAVEHDR));
  if (!header_handle) return;

  header_ptr = (WAVEHDR *)GlobalLock(header_handle);

  header_ptr->lpData         = data_ptr;
  header_ptr->dwBufferLength = format.nSamplesPerSec / 5;
  header_ptr->dwFlags        = 0;
  header_ptr->dwLoops        = 0;

  if (waveOutOpen(&device, WAVE_MAPPER, &format, 0, 0, WAVE_ALLOWSYNC)
          != MMSYSERR_NOERROR) return;

  waveOutPrepareHeader(device, header_ptr, sizeof(WAVEHDR));

  sample_size = 44100 / 20;

#else
#  ifdef HAVE_ALSA_ASOUNDLIB_H
  handle = NULL;

  if (snd_pcm_open(&handle, "default", SND_PCM_STREAM_PLAYBACK, 0) >= 0) {
    // Initialize PCM sound stuff...
    snd_pcm_hw_params_t *params;

    snd_pcm_hw_params_alloca(&params);
    snd_pcm_hw_params_any(handle, params);
    snd_pcm_hw_params_set_access(handle, params, SND_PCM_ACCESS_RW_INTERLEAVED);
    snd_pcm_hw_params_set_format(handle, params, SND_PCM_FORMAT_S16);
    snd_pcm_hw_params_set_channels(handle, params, 2);
    unsigned rate = 44100;
    int dir;
    snd_pcm_hw_params_set_rate_near(handle, params, &rate, &dir);
    snd_pcm_uframes_t period = (int)rate / 4;
    snd_pcm_hw_params_set_period_size_near(handle, params, &period, &dir);

    sample_size = rate / 20;

    if (snd_pcm_hw_params(handle, params) < 0) {
      sample_size = 0;
      snd_pcm_close(handle);
      handle = NULL;
    }
  }
#  endif // HAVE_ALSA_ASOUNDLIB_H
#endif // __APPLE__

  if (sample_size) {
    // Make each of the notes using a combination of sine and sawtooth waves
    int attack = sample_size / 10;
    int decay = 4 * sample_size / 5;

    for (int i = 0; i < 9; i ++) {
      sample_data[i] = new short[2 * sample_size];

      short *sample_ptr = sample_data[i];

      for (int j = 0; j < sample_size; j ++, sample_ptr += 2) {
        double theta = 0.05 * frequencies[i] * j / sample_size;
        double val = 0.5 * sin(2.0 * M_PI * theta) + theta - (int)theta - 0.5;

        if (j < attack) {
	  *sample_ptr = (int)(32767 * val * j / attack);
	} else if (j > decay) {
	  *sample_ptr = (int)(32767 * val * (sample_size - j + decay) /
	                      sample_size);
	} else *sample_ptr = (int)(32767 * val);

        sample_ptr[1] = *sample_ptr;
      }
    }
  }
}

// Cleanup the SudokuSound class
SudokuSound::~SudokuSound() {
#ifdef __APPLE__
  if (sample_size) {
    AudioDeviceStop(device, audio_cb);
    AudioDeviceRemoveIOProc(device, audio_cb);
  }

#elif defined(WIN32)
  if (sample_size) {
    waveOutClose(device);

    GlobalUnlock(header_handle);
    GlobalFree(header_handle);

    GlobalUnlock(data_handle);
    GlobalFree(data_handle);
  }

#else
#  ifdef HAVE_ALSA_ASOUNDLIB_H
  if (handle) {
    snd_pcm_drain(handle);
    snd_pcm_close(handle);
  }
#  endif // HAVE_ALSA_ASOUNDLIB_H
#endif // __APPLE__

  if (sample_size) {
    for (int i = 0; i < 9; i ++) {
      delete[] sample_data[i];
    }
  }
}

#ifdef __APPLE__
// Callback function for writing audio data...
OSStatus
SudokuSound::audio_cb(AudioDeviceID device,
								      const AudioTimeStamp *current_time,
								      const AudioBufferList *data_in,
								      const AudioTimeStamp *time_in,
								      AudioBufferList *data_out,
								      const AudioTimeStamp *time_out,
								      void *client_data)
{
  SudokuSound *ss = (SudokuSound *)client_data;
  int count;
  float *buffer;

  if (!ss->remaining) return noErr;

  for (count = data_out->mBuffers[0].mDataByteSize / sizeof(float),
          buffer = (float*) data_out->mBuffers[0].mData;
       ss->remaining > 0 && count > 0;
       count --, ss->data ++, ss->remaining --) {
    *buffer++ = *(ss->data) / 32767.0;
  }

  while (count > 0) {
    *buffer++ = 0.0;
    count --;
  }

  return noErr;
}
#endif // __APPLE__

// switch sound on or off
void SudokuSound::soundon(int on)
{
	soundon_ = on;
	 //1 is on 
}

// Play a note for 250ms...
void SudokuSound::play(char note) 
{
  if (!soundon_ ) return;
  Fl::check();

#ifdef __APPLE__
  // Point to the next note...
  data      = sample_data[note - 'A'];
  remaining = sample_size * 2;

  // Wait for the sound to complete...
  usleep(50000);

#elif defined(WIN32)
  if (sample_size) {
    memcpy(data_ptr, sample_data[note - 'A'], sample_size * 4);

    waveOutWrite(device, header_ptr, sizeof(WAVEHDR));

    Sleep(50);
  } else Beep(frequencies[note - 'A'], 50);

#else
#  ifdef HAVE_ALSA_ASOUNDLIB_H
  if (handle) {
    // Use ALSA to play the sound...
    if (snd_pcm_writei(handle, sample_data[note - 'A'], sample_size) < 0) {
      snd_pcm_prepare(handle);
      snd_pcm_writei(handle, sample_data[note - 'A'], sample_size);
    }
    usleep(50000);
    return;
  }
#  endif // HAVE_ALSA_ASOUNDLIB_H

  // Just use standard X11 stuff...
  XKeyboardState	state;
  XKeyboardControl	control;

  // Get original pitch and duration...
  XGetKeyboardControl(fl_display, &state);

  // Sound a tone for the given note...
  control.bell_percent  = 100;
  control.bell_pitch    = frequencies[note - 'A'];
  control.bell_duration = 50;

  XChangeKeyboardControl(fl_display,
                         KBBellPercent | KBBellPitch | KBBellDuration,
			 &control);
  XBell(fl_display, 100);
  XFlush(fl_display);

  // Restore original pitch and duration...
  control.bell_percent  = state.bell_percent;
  control.bell_pitch    = state.bell_pitch;
  control.bell_duration = state.bell_duration;

  XChangeKeyboardControl(fl_display,
                         KBBellPercent | KBBellPitch | KBBellDuration,
			 &control);
#endif // __APPLE__
}

// Create a cell widget
SudokuCell::SudokuCell(int X, int Y, int W, int H)
  : Fl_Widget(X, Y, W, H, 0) 
{
  valueSet(0);
  uniquehintSet(0); //<1,9> as reall values
}

// Draw cell
void
SudokuCell::draw() {
  static Fl_Align align[] = {
  	(Fl_Align)DUMMY, /* value 0 never displayed */
    FL_ALIGN_TOP_LEFT,
    FL_ALIGN_TOP,
    FL_ALIGN_TOP_RIGHT,
    FL_ALIGN_LEFT,
    FL_ALIGN_CENTER,
    FL_ALIGN_RIGHT,
    FL_ALIGN_BOTTOM_LEFT,
    FL_ALIGN_BOTTOM,
    FL_ALIGN_BOTTOM_RIGHT
  };

  // Draw the cell box...
  if (readonlyGet()) fl_draw_box(FL_UP_BOX, x(), y(), w(), h(), color());
  else fl_draw_box(FL_DOWN_BOX, x(), y(), w(), h(), color());

  // Draw the cell background...
  if (Fl::focus() == this) {
    Fl_Color c = fl_color_average(FL_SELECTION_COLOR, color(), 0.5f);
    fl_color(c);
    fl_rectf(x() + 4, y() + 4, w() - 8, h() - 8);
    fl_color(fl_contrast(labelcolor(), c));
  } else fl_color(labelcolor());

  // Draw the cell value...
  char s[2];

  s[1] = '\0';

  if (value_) {
    s[0] = value_ + '0'; //itoa

    fl_font(FL_HELVETICA_BOLD, h() - 10);
    fl_draw(s, x(), y(), w(), h(), FL_ALIGN_CENTER);
  }

  //draw the test values
  fl_color(FL_RED);
  fl_font(FL_HELVETICA_BOLD, h() / 5);

  for (int i = 1; i <= 9; i ++) {
    if (hints_[i]) 
    {
      //set drawing color
      if (uniquehintGet() ==	hints_[i])
      {
      	fl_color(FL_BLACK);
      	
      }
      s[0] = hints_[i] + '0';
      fl_draw(s, x() + 5, y() + 5, w() - 10, h() - 10, align[i]);
      
      //afterward reset the drawing color back to red
      if (uniquehintGet() == hints_[i])
      {
      	fl_color(FL_RED);
      }
    }
  }
}

void
SudokuCell::init(int x, int y)
{
	 myI = x;
	 myJ = y;
}

// Handle events in cell
int
SudokuCell::handle(int event)
{
  //printf("event = %s\n",names[event]);	
  switch (event) 
  {
    case FL_FOCUS :
      Fl::focus(this);
      ((Sudoku *)window())->setFocusCell(myI,myJ);
      //printf("cellhandler focuscell = [%d,%d]\n", myI, myJ);
      redraw();
      return 1;

    case FL_UNFOCUS :
      //((Sudoku *)window())->setFocusCell(-1,-1);
      //printf("cellhandler focuscell = [%d,%d]\n", -1, -1);
      redraw();
      return 1;
      break;

    case FL_PUSH :
      if (Fl::event_inside(this)) 
      {
        if (Fl::event_clicks()) 
        {
		  // 2+ clicks increments/sets value
		  if (valueGet()) 
		  {
			if (valueGet() < 9) valueSet(valueGet() + 1);
			else valueSet(1);
	      } 
	      else valueSet(((Sudoku *)window())->next_value(this));
			}
        ((Sudoku *)window())->setFocusCell(myI,myJ);
        Fl::focus(this);
     	redraw();
    	return 1;
      }
      break;

    case FL_KEYDOWN :
      if (Fl::event_state() & FL_CTRL) break;
      
      int key = Fl::event_key() - '0';
      Sudoku* s = (Sudoku *)window();
      
     
      
      if (key < 0 || key > 9) key = Fl::event_key() - FL_KP - '0';//keypad keys
      
      if (key > 0 && key <= 9) 
      { 
        if (readonlyGet()) 
        {
          fl_beep(FL_BEEP_ERROR);
          return 1;
        }

        if (Fl::event_state() & (FL_SHIFT | FL_CAPS_LOCK)) 
        {
	      //add hint
		  if (hintsGet(key) )
		  {
		  	//remove it exists
		   	hintsRemove(key);
		  }	
		  else
		  {
		  	//does not exist write it
	        test_valueSet(key, DUMMY);
		  }
		  if ( s->getautounique() ) s->showuniquehints();
		  if ( s->getpromoteunique() ) s->promoteuniquehints();
		  redraw();
	 	} 
		else 
		{
		  //add a user value	
		  valueSet(key);
		  if ( s->getautohints() ) s->updatehintsfromthis(myI, myJ);
		  
		  if ( s->getautounique() ) s->showuniquehints();
		  if ( s->getpromoteunique() ) s->promoteuniquehints();
		  do_callback();
		}
		return 1;
      } 
      else if (key == 0 || Fl::event_key() == FL_BackSpace ||
                 Fl::event_key() == FL_Delete) 
      {
        if (readonlyGet()) 
        {
          fl_beep(FL_BEEP_ERROR);
          return 1;
        }
        
        valueSet(0);
        //draw hints for this cell if autohints is on
        if (s->getautohints()) { s->hintthiscell(myI, myJ); }
        
	    do_callback();
    	return 1;
      }
      /*
      else if (Fl::event_key() =='h')
      {
      	//printf("cell handler h key pressed\n");
      	s->hintthiscell(myI, myJ);
      }
      else if (Fl::event_key() =='u')
      {
       	//printf("cell handler u key pressed [%d,%d]\n", myI, myJ);
       	s->updatehintsfromthis(myI, myJ);
      }
      */      
      else if (Fl::event_key() == ' ')
      {      
       	s->cleanBackgrounds();
      }
      break;
  }
  return Fl_Widget::handle(event);
}

// Sudoku class globals...
Fl_Help_Dialog	*Sudoku::help_dialog_ = (Fl_Help_Dialog *)0;
Fl_Preferences	Sudoku::prefs_(Fl_Preferences::USER, "fltk.org", "sudoku");

// Create a Sudoku game window...
Sudoku::Sudoku()
  : Fl_Window(GROUP_SIZE * 3, GROUP_SIZE * 3 + MENU_OFFSET, "Sudoku")
{
  int i, j;
  solvechecks = 0;
  Fl_Group *g;
  SudokuCell *cell;
  static Fl_Menu_Item	items[] = {
    { "&Game", 0, 0, 0, FL_SUBMENU },
    { "&New Puzzle", FL_COMMAND | 'n', new_cb, 0, FL_MENU_DIVIDER },
    { "&Check Game", FL_COMMAND | 'c', check_cb, 0, 0 },
    { "&Restart Game", FL_COMMAND | 'r', restart_cb, 0, 0 },
    { "&Solve Game", FL_COMMAND | 's', showSolution_cb, 0, FL_MENU_DIVIDER },
    
    { "&Input Puzzle", FL_COMMAND | 'i', input_cb, 0, 0},
    { "Save Puzzle", FL_COMMAND | 'x', savepuzzle_cb, 0, 0},
    { "S&ave Game", FL_COMMAND | 'a', savegame_cb, 0, 0},
    { "&Load Game", FL_COMMAND | 'l', loadgame_cb, 0, FL_MENU_DIVIDER },
    { "&Quit", FL_COMMAND | 'q', close_cb, 0, 0 },
    { 0 },
    { "&Difficulty", 0, 0, 0, FL_SUBMENU },
    { "&Easy(50)", 0, diff_cb, (void *)"0", FL_MENU_RADIO },
    { "&Medium(40)", 0, diff_cb, (void *)"1", FL_MENU_RADIO },
    { "&Hard(30)", 0, diff_cb, (void *)"2", FL_MENU_RADIO },
    { "&Impossible(20)", 0, diff_cb, (void *)"3", FL_MENU_RADIO },
    { 0 },
    { "&Functions", 0, 0, 0, FL_SUBMENU },
    { "Has &Sound", FL_ALT | 's' , hassound_cb, 0, FL_MENU_TOGGLE },   
    { "&Hints", FL_COMMAND | 'h', hints_cb, 0,0 },    
    { "&Hint This cell", FL_ALT | 'h', hintthis_cb, 0,0 }, 
    { "&Update Hints from this cell", FL_COMMAND | 'u', updatehintsfromthis_cb, 0,0 }, 
    { "Auto hints update", 0 , autohints_cb, 0, FL_MENU_TOGGLE },  
    { "Show unique hints", FL_COMMAND | '1', showuniquehints_cb, 0,0 }, 
    { "Auto unique hints", 0 , autounique_cb, 0, FL_MENU_TOGGLE },  
    { "&Promote unique to values", FL_COMMAND | 'p', promoteunique_cb, 0,0 }, 
    { "Auto promote unique to values", 0 , autopromoteunique_cb, 0, FL_MENU_TOGGLE },  
    { "&Remove Hints", FL_ALT | 'r', removehints_cb, 0,0 },   
    { "Show this value", '?', showthisvalue_cb, 0,0 },   
    { "**todo**Help me", 0, helpme_cb, 0,0 },   
    { "Calculate number of solutions", 0, NumberOfSolutions_cb, 0,0 },   
    { 0 },
    { "Help", 0, 0, 0, FL_SUBMENU },  //NO &Help (h shortcut key because h = cell hint)
    { "&About Sudoku", FL_F + 1, help_cb, 0, 0 },
    { 0 },
    { 0 }
  };

  // Setup sound output...
  sound_ = new SudokuSound();

  // Menubar...
  prefs_.get("difficulty", difficulty_, 0);

  prefs_.get("hassound", hassound_, 1);  //1 is default???
  sound_->soundon(hassound_);
  
  prefs_.get("autohints", autohints_, 0);  //0 is default???
  
  prefs_.get("autounique", autounique_, 0);  //0 is default???

  prefs_.get("promoteunique", promoteunique_, 0);  //0 is default???

  prefs_.get("hassolution", hassolution_, 0);  //0 is default???

  if (difficulty_ < 0 || difficulty_ > 3) difficulty_ = 0;
  //PLJ 8 = old items in first menu, 4 add plj items in first menu
  items[8 + 4 +  difficulty_].flags |= FL_MENU_VALUE;
  
  //set sound toggle
  //PLJ 18 = has sound item??
  if (hassound_) items[18].flags |= FL_MENU_VALUE;

  //PLJ set autohint toggle 23 = autohints item??  
  if (autohints_) items[22].flags |= FL_MENU_VALUE;
  
  //PLJ set autounique toggle 24 = autounique item??  
  if (autounique_) items[24].flags |= FL_MENU_VALUE;
  
  //PLJ set autounique toggle 26 = promoteunique item??  
  if (promoteunique_) items[26].flags |= FL_MENU_VALUE;

  menubar_ = new Fl_Sys_Menu_Bar(0, 0, 3 * GROUP_SIZE, 25);
  menubar_->menu(items);

  // Create the grids...
  grid_ = new Fl_Group(0, MENU_OFFSET, 3 * GROUP_SIZE, 3 * GROUP_SIZE);

  for (i = 0; i < 3; i ++)
    for (j = 0; j < 3; j ++) {
      g = new Fl_Group(j * GROUP_SIZE, i * GROUP_SIZE + MENU_OFFSET,
		       GROUP_SIZE, GROUP_SIZE);
      g->box(FL_BORDER_BOX);
      if ((i == 1) ^ (j == 1)) g->color(FL_DARK3);
      else g->color(FL_DARK2);
      g->end();

      grid_groups_[i][j] = g;
    }

  for (i = 0; i < 9; i ++)
    for (j = 0; j < 9; j ++) {
      cell = new SudokuCell(j * CELL_SIZE + CELL_OFFSET +
                                (j / 3) * (GROUP_SIZE - 3 * CELL_SIZE),
	                    i * CELL_SIZE + CELL_OFFSET + MENU_OFFSET +
			        (i / 3) * (GROUP_SIZE - 3 * CELL_SIZE),
			    CELL_SIZE, CELL_SIZE);
      cell->callback(cell_callback);
      cell->init(i,j);
      grid_cells_[i][j] = cell;
    }

  // Set icon for window (MacOS uses app bundle for icon...)
#ifdef WIN32
  icon((char *)LoadIcon(fl_display, MAKEINTRESOURCE(IDI_ICON)));
#elif !defined(__APPLE__)
  fl_open_display();
  icon((char *)XCreateBitmapFromData(fl_display, DefaultRootWindow(fl_display),
                                     (char *)sudoku_bits, sudoku_width,
				     sudoku_height));
#endif // WIN32

  // Catch window close events...
  callback(close_cb);

  // Make the window resizable...
  resizable(grid_);
  size_range(3 * GROUP_SIZE, 3 * GROUP_SIZE + MENU_OFFSET, 0, 0, 5, 5, 1);

  // Restore the previous window dimensions...
  int X, Y, W, H;

  if (prefs_.get("x", X, -1)) 
  {
    prefs_.get("y", Y, -1);
    prefs_.get("width", W, 3 * GROUP_SIZE);
    prefs_.get("height", H, 3 * GROUP_SIZE + MENU_OFFSET);

    resize(X, X, W, H);
    
    lastFocusI = -1; //init as no focus yet
    lastFocusJ = -1;
  }

  set_title();
  
  //PLJ
  import_stopped = false;
  //teller = 0;
}

// Destroy the sudoku window...
Sudoku::~Sudoku()
{
  delete sound_;
}

// Check for a solution to the game...
void
Sudoku::check_cb(Fl_Widget *widget, void *) 
{
  ((Sudoku *)(widget->window()))->check_game();
}

// Check if the user has correctly solved the game...
void
Sudoku::check_game(bool highlight) 
{
  bool empty = false;
  bool correct = true;
  int i, j, k;

  // Check the game for right/wrong answers...
  for (i = 0; i < 9; i ++)
    for (j = 0; j < 9; j ++) 
    {
      SudokuCell *cell = grid_cells_[i][j];
      int val = cell->valueGet();

      if (cell->readonlyGet()) continue;

      if (!val) empty = true;
      else 
      {
        for (k = 0; k < 9; k ++)
          if ((i != k && grid_cells_[k][j]->valueGet() == val) ||
	      (j != k && grid_cells_[i][k]->valueGet() == val)) break;

        if (k < 9) 
        {
          if (highlight) 
          {
     	    cell->color(FL_YELLOW);
	       cell->redraw();
	      }
    	  correct = false;
	    } 
	    else if (highlight) 
	    {
    	  cell->color(FL_LIGHT3);
	      cell->redraw();
	    } 
      }
    }

  // Check subgrids for duplicate numbers...
  for (i = 0; i < 9; i += 3)
    for (j = 0; j < 9; j += 3)
      for (int ii = 0; ii < 3; ii ++)
        for (int jj = 0; jj < 3; jj ++) {
	  SudokuCell *cell = grid_cells_[i + ii][j + jj];
	  int val = cell->valueGet();

	  if (cell->readonlyGet() || !val) continue;

          int iii;

          for (iii = 0; iii < 3; iii ++) {
	    int jjj;

	    for (jjj = 0; jjj < 3; jjj ++)
              if (ii != iii && jj != jjj &&
	          grid_cells_[i + iii][j + jjj]->valueGet() == val) break;

            if (jjj < 3) break;
	  }

          if (iii < 3) {
            if (highlight) {
	      cell->color(FL_YELLOW);
	      cell->redraw();
	    }

	    correct = false;
	  }
	}

  if (!empty && correct) {
    // Success!
    for (i = 0; i < 9; i ++) {
      for (j = 0; j < 9; j ++) {
	SudokuCell *cell = grid_cells_[i][j];
	cell->color(FL_GREEN);
	cell->readonlySet(1);
      }

      sound_->play('A' + grid_cells_[i][8]->valueGet() - 1);
    }
  }
}//check_cb

// Close the window, saving the game first...
void
Sudoku::close_cb(Fl_Widget *widget, void *) {
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);

  s->save_pref_game();
  s->hide();

  if (help_dialog_) help_dialog_->hide();
}

// Set the level of difficulty...
void
Sudoku::diff_cb(Fl_Widget *widget, void *d)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int diff = atoi((char *)d);
 
  if ((!s->hassolution_) ||(diff != s->difficulty_))//prev was imported or a different difficulty
  {
    s->difficulty_ = diff;
    
    //switch back from imported files
    s->hassolution_ = 1;
    prefs_.set("hassolution", s->hassolution_);
    
    s->new_game(s->seed_);
    s->set_title();

    prefs_.set("difficulty", s->difficulty_);
  }
}

// Show the on-line help...
void
Sudoku::help_cb(Fl_Widget *, void *) 
{
  if (!help_dialog_) 
  {
    help_dialog_ = new Fl_Help_Dialog();

    help_dialog_->value(
	"<HTML>\n"
	"<HEAD>\n"
	"<TITLE>Sudoku Help</TITLE>\n"
	"</HEAD>\n"
	"<BODY BGCOLOR='#ffffff'>\n"
    "Version " VERSION  "."   BUILD  "\n"
	"<H2>About the Game</H2>\n"

	"<P>Sudoku (pronounced soo-dough-coo with the emphasis on the\n"
        "first syllable) is a simple number-based puzzle/game played on a\n"
	"9x9 grid that is divided into 3x3 subgrids. The goal is to enter\n"
	"a number from 1 to 9 in each cell so that each number appears\n"
	"only once in each column and row. In addition, each 3x3 subgrid\n"
	"may only contain one of each number.</P>\n"

	"<P>This version of the puzzle is Copyright 2005 by Michael R Sweet</P>\n"

	"<H2>How to Play the Game</H2>\n"

	"<P>At the start of a new game, Sudoku fills in a random selection\n"
	"of cells for you - the number of cells depends on the difficulty\n"
	"level you use. Click in any of the empty cells or use the arrow\n"
	"keys to highlight individual cells and press a number from 1 to 9\n"
	"to fill in the cell. To clear a cell, press 0, Delete, or\n"
	"Backspace. When you have successfully completed all subgrids, the\n"
	"entire puzzle is highlighted in green until you start a new\n"
	"game.</P>\n"

	"<P>As you work to complete the puzzle, you can display possible\n"
	"solutions inside each cell by holding the Shift key and pressing\n"
	"each number in turn. Repeat the process to remove individual\n"
	"numbers, or press a number without the Shift key to replace them\n"
	"with the actual number to use.</P>\n"
	"</BODY>\n"
    );
  }
  help_dialog_->show();
}//help_cb

// Load the game from saved preferences...
void
Sudoku::load_pref_game() 
{
  // Load the current values and state of each grid...
  memset(grid_values_, 0, sizeof(grid_values_));

  bool solved = true;

  bool hasHints = false; //only autohints if no hints stored, don't spoil the users bookkeeping
  for (int i = 0; i < 9; i ++)
    for (int j = 0; j < 9; j ++) 
    {
      char name[255];
      int val;

      SudokuCell *cell = grid_cells_[i][j];

      sprintf(name, "value%d.%d", i, j);
      if (!prefs_.get(name, val, 0)) 
      {
        i = 9;
    	grid_values_[0][0] = 0;
	    break;
      }

      grid_values_[i][j] = val;

      sprintf(name, "state%d.%d", i, j);
      prefs_.get(name, val, 0);
      cell->valueSet(val);
 
      sprintf(name, "readonly%d.%d", i, j);
      prefs_.get(name, val, 0);
      cell->readonlySet(val);

      if (val) cell->color(FL_GRAY);
      else 
      {
        cell->color(FL_LIGHT3);
      	solved = false;
      }

      for (int k = 0; k < 10; k ++) 
      {
        sprintf(name, "test%d%d.%d", k, i, j);
        prefs_.get(name, val, 0);
        cell->test_valueSet(val, k);
        if ((val == k) && (k!=0)) {hasHints = true;}
        //printf("test idx:%d ? %d  (%d,%d)\n", k, val, i, j);
      }
    }

  // If we didn't load any values or the last game was solved, then
  // create a new game automatically...
  //TEMP remove to allow continueing imported games which are not complete

  prefs_.get("difficulty", difficulty_, 0);

  prefs_.get("hassound", hassound_, 1);  //1 is default???
  sound_->soundon(hassound_);
  
  prefs_.get("autohints", autohints_, 0);  //0 is default???
  
  prefs_.get("autounique", autounique_, 0);  //0 is default???

  prefs_.get("promoteunique", promoteunique_, 0);  //0 is default???
    
  prefs_.get("hassolution", hassolution_, 0);  //0 is default???
  
  if (solved || !grid_values_[0][0]) new_game(time(NULL));
  else check_game(false);
  
  if (!hasHints && autohints_)
  {
  	//only autohints if no hints stored, don't spoil the users bookkeeping
    hints();
  }
  
  if (autounique_) showuniquehints();
}

// Create a new game...
void
Sudoku::new_cb(Fl_Widget *widget, void *) 
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);

  if (s->grid_cells_[0][0]->color() != FL_GREEN) {
    if (!fl_choice("Are you sure you want to change the difficulty level and "
                   "discard the current game?", "Keep Current Game", "Start New Game",
                   NULL)) return;
  }

  s->new_game(time(NULL));
}

// Create a new game...
void
Sudoku::new_game(time_t seed)
{
  int i, j, k, m, t, count;

  // Generate a new (valid) Sudoku grid...
  seed_ = seed;
  srand(seed);

  memset(grid_values_, 0, sizeof(grid_values_));
  //PLJ reset the hints
  
  for (i = 0; i < 9; i += 3) 
  {
    for (j = 0; j < 9; j += 3) 
    {
      for (t = 1; t <= 9; t ++) 
      {
	    for (count = 0; count < 20; count ++) 
	    {
      	  k = i + (rand() % 3);
	      m = j + (rand() % 3);
    	  if (!grid_values_[k][m]) 
    	  {
    	    int kk;

	        for (kk = 0; kk < k; kk ++)
	          if (grid_values_[kk][m] == t) break;

    	    if (kk < k) continue;

	        int mm;

	        for (mm = 0; mm < m; mm ++)
    	      if (grid_values_[k][mm] == t) break;

	        if (mm < m) continue;

	        grid_values_[k][m] = t;
	        break;
	      }
        }

	    if (count == 20) 
	    {
		  // Unable to find a valid puzzle so far, so start over...
		  j = 9;
		  i = -3;
		  memset(grid_values_, 0, sizeof(grid_values_));
     	}
      }
    }
  }

  // Start by making all cells editable
  SudokuCell *cell;

  for (i = 0; i < 9; i ++)
    for (j = 0; j < 9; j ++) {
      cell = grid_cells_[i][j];

      cell->valueSet(0);
      cell->readonlySet(0);
      cell->color(FL_LIGHT3);
      //hints etc. what about hintvalues??
      cell->resetHints();
    }

  // Show N cells...
  count = 10 * (5 - difficulty_);

  int numbers[9];

  for (i = 0; i < 9; i ++) numbers[i] = i + 1;

  while (count > 0) 
  {
    for (i = 0; i < 20; i ++) 
    {
      k          = rand() % 9;
      m          = rand() % 9;
      t          = numbers[k];
      numbers[k] = numbers[m];
      numbers[m] = t;
    }

    for (i = 0; count > 0 && i < 9; i ++) 
    {
      t = numbers[i];

      for (j = 0; count > 0 && j < 9; j ++) 
      {
        cell = grid_cells_[i][j];

        if (grid_values_[i][j] == t && !cell->readonlyGet()) 
        {
    	  cell->valueSet(grid_values_[i][j]);
	      cell->readonlySet(1);
    	  cell->color(FL_GRAY);

	      count --;
    	  break;
	    }
      }

      sound_->play('A' + t - 1);
    }
  }
  //if auto update hints run hints
  if (autohints_)
  {
    hints();
  }
}// new_game

// Return the next available value for a cell...
int
Sudoku::next_value(SudokuCell *c) 
{
  int	i, j, k, m;

  //find the focus cell:
  for (i = 0; i < 9; i ++) 
  {
    for (j = 0; j < 9; j ++)
      if (grid_cells_[i][j] == c) break;

    if (j < 9) break;
  }

  if (i == 9) return 1; //cel not found return??

  //set index to top of box??
  i -= i % 3;
  j -= j % 3;

  //the availabble numbers inited at 0
  int numbers[9];
  memset(numbers, 0, sizeof(numbers));

  //loop box
  for (k = 0; k < 3; k ++)
    for (m = 0; m < 3; m ++) {
      c = grid_cells_[i + k][j + m];
      if (c->valueGet()) numbers[c->valueGet() - 1] = 1;
    }

  //loop results till first empty one
  for (i = 0; i < 9; i ++)
    if (!numbers[i]) return i + 1;

  //nothing found return
  return 1;
}

// Reset widget color to gray...
void
Sudoku::cell_callback(Fl_Widget *widget, void *) {
  widget->color(FL_LIGHT3);
  widget->redraw();
  
  ((Sudoku *)(widget->window()))->check_game(false);
}

// Resize the window...
void
Sudoku::resize(int X, int Y, int W, int H) {
  // Resize the window...
  Fl_Window::resize(X, Y, W, H);

  // Save the new window geometry...
  prefs_.set("x", X);
  prefs_.set("y", Y);
  prefs_.set("width", W);
  prefs_.set("height", H);
}


// Restart game from beginning...
void
Sudoku::restart_cb(Fl_Widget *widget, void *) {
  Sudoku *s = (Sudoku *)(widget->window());
  bool solved = true;

  for (int i = 0; i < 9; i ++)
    for (int j = 0; j < 9; j ++) {
      SudokuCell *cell = s->grid_cells_[i][j];

      if (!cell->readonlyGet()) {
        solved = false;
        int v = cell->valueGet();
	cell->valueSet(0);
	cell->color(FL_LIGHT3);
	if (v) s->sound_->play('A' + v - 1);
      }
    }

  if (solved) s->new_game(s->seed_);
}

// Save the current game state...
void
Sudoku::save_pref_game() {
  // Save the current values and state of each grid...
  for (int i = 0; i < 9; i ++)
    for (int j = 0; j < 9; j ++) {
      char name[255];
      SudokuCell *cell = grid_cells_[i][j];

      sprintf(name, "value%d.%d", i, j);
      prefs_.set(name, grid_values_[i][j]);

      sprintf(name, "state%d.%d", i, j);
      prefs_.set(name, cell->valueGet());

      sprintf(name, "readonly%d.%d", i, j);
      prefs_.set(name, cell->readonlyGet());

      for (int k = 0; k < 10; k ++) {
	sprintf(name, "test%d%d.%d", k, i, j);
	prefs_.set(name, cell->hintsGet(k));
      }
    }
}

// Set title of window...
void
Sudoku::set_title() {
  static const char * const titles[] = {
    "Sudoku - Easy",
    "Sudoku - Medium",
    "Sudoku - Hard",
    "Sudoku - Impossible",
    "Sudoku - !!Imported!!"
  };
  int labelitem = difficulty_;
  if (!hassolution_) labelitem = 4;
  
  label(titles[labelitem]);
}

// Solve the puzzle...
void
Sudoku::showSolution_cb(Fl_Widget *widget, void *) 
{
  //((Sudoku *)(widget->window()))->solve_game();
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);

  s->showSolution_game();
}

// Solve the puzzle...
void
Sudoku::showSolution_game() 
{
  //PLJ check if not in imported mode  
  if ( !hassolution_) // if import do nothing
  {
  	//TODO geef user feedback dat deze game imported is
  	return;
  }
  
  int i, j;

  for (i = 0; i < 9; i ++) {
    for (j = 0; j < 9; j ++) {
      SudokuCell *cell = grid_cells_[i][j];

      cell->valueSet(grid_values_[i][j]);
      cell->readonlySet(1);
      cell->color(FL_GRAY);
    }
    sound_->play('A' + grid_cells_[i][8]->valueGet() - 1);
  }
}

//Import the puzzle...
void 
Sudoku::input_cb(Fl_Widget *widget, void *) 
{
  //((Sudoku *)(widget->window()))->import_game();
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  const char * import = fl_input("new sudoku:", "...1237...");
  if (import != NULL) 
  {
	  printf("import=%s\n", import);                   
	  s->input_game((char *)import);
	  
	  s->hassolution_ = 0; //imported
	  s->set_title();
	  prefs_.set("hassolution", s->hassolution_);
  }
}

// Solve the puzzle...
void
Sudoku::input_game(char * import) 
{
  memset(grid_values_, 0, sizeof(grid_values_));

  //printf("import=%s\n", import);
  //printf("sizeof(import)=[%d]\n", sizeof(*import));
  
  //printf("====\n\n");
  int teller = 0;  //0 tot 80 for grid
  import_stopped = false;
    
  int value;
  //start looping the grid
  for (int i = 0; i < 9; i ++)
  {
    for (int j = 0; j < 9; j ++) 
    { 
      //read next value for this cell
      value = getNextValue(import, teller);
      //printf("%d:(%2d, %2d)=[%d]\n", teller,i,j,value);	
      //get the cell
      SudokuCell *cell = grid_cells_[i][j];
        
      if ( (value >= 1) && (value <= 9) )
      {
	      grid_values_[i][j]= value;
	      cell->valueSet(value);      
		  cell->readonlySet(1);
		  cell->color(FL_GRAY);	
      }
      else
      {
		  //if empty cell 0 / . / EOF
		  grid_values_[i][j]= 0;
	      cell->valueSet(0);
	      cell->readonlySet(0);
	      cell->color(FL_LIGHT3);
      }
      teller++;
    }
  }//end loop
  //check for TOO LONG import string (read if char82 is valid)
  value = getNextValue(import, teller);
  if (!import_stopped)
  {
  	  //TODO feedback to the user
	  printf("import string is TOO LONG, ignring additional characters!!!\n");	
  }
}//import_game the puzzle

int 
Sudoku::getNextValue(char* import, int teller )
{
  int result = 0;
  //printf("teller=%d\n", teller);
    
  char tempchar = import[teller];
  if (tempchar =='\0') {import_stopped = true;}
  
  if (!import_stopped ) 
  {  	
    //printf("next char=[%c]", tempchar);	
  	
  	if (tempchar <= '0')
  	{ 
  		result = 0;
  		//printf("  te klein\n");
  	}
  	else if (tempchar > '9')
  	{ 
  		result = 0;
		//printf("  te groot\n");		
  	}
  	else 
  	{
  		result = tempchar - '0';
  		//printf("  correct [%d]\n", result);		
  	}
  }	
  return result;
}//getNextValue

void
Sudoku::savepuzzle_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
    
  char* filename = fl_file_chooser("export puzzle", "*.sdk", ".", 0); //relative = 0
  //printf("filename = %s\n", filename);

  ofstream myfile;
  myfile.open (filename);

  if (myfile.is_open())
  {
	  for (int i=0; i<9;i++)
	  	for (int j=0;j<9;j++)
	  	{
	  		
	  		SudokuCell *tempcell; 
	  		tempcell = s->grid_cells_[i][j];
	  		if (tempcell->readonlyGet())
	  		{
	    		myfile << tempcell->valueGet();
	  		}  		
	  		else
	  		{
	  				myfile << ".";
	  		}
	 	}
	  myfile.close();
  }//if open
}

void
Sudoku::savegame_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
    
  char* filename = fl_file_chooser("save game", "*.su", ".", 0); //relative = 0
  //printf("filename = %s\n", filename);

  ofstream myfile;
  myfile.open (filename);
  if (myfile.is_open())
  {
	  for (int i=0; i<9;i++)
	  	for (int j=0;j<9;j++)
	  	{
	      SudokuCell *tempcell; 
	      tempcell = s->grid_cells_[i][j];
	  	  if (tempcell->readonlyGet())
	  	  {
	        myfile << tempcell->valueGet();
	  	  }  		
	  	  else
	  	  {
	        myfile << ".";
	  	  }
	 	}
	
		myfile << "\n";
	
	 	//cell per line value, hints list; value = 0 if no value 
	   for (int i=0; i<9;i++)
	  	for (int j=0;j<9;j++)
	  	{
	 		SudokuCell *tempcell; 
	  		tempcell = s->grid_cells_[i][j];
	  		myfile << i << "," << j << ":";
	  		
	   		myfile << tempcell->valueGet();
	        for (int h = 1; h <=9 ; h++)
	        {
	        	int hint =  tempcell->hintsGet(h);
	        	if (hint) myfile << hint;
	        }    		
	        myfile << "\n";
	  	}	
	 	
	  myfile.close();
  }// if open
}

void
Sudoku::loadgame_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  SudokuCell *tempcell; 
  const int MAXLINESIZE = 85;
  char line[MAXLINESIZE]; 
  int index = 0;
  int i,j;
    
  char* filename = fl_file_chooser("load game", "*.su", ".", 0); //relative = 0
  //printf("filename = %s\n", filename);

  //if file exist start reading
  //FILE IO based on http://www.cplusplus.com/doc/language/tutorial/files.html ,Thanx guys
  ifstream myfile (filename);
  if (myfile.is_open())
  {
    //clean up all cell to make a new puzzle:  	
    for (int ii = 0; ii < 9; ii ++)
    {
      for (int jj = 0; jj < 9; jj ++) 
      {
        SudokuCell * cell = s->grid_cells_[ii][jj];

        cell->valueSet(0);
        cell->readonlySet(0);
        cell->color(FL_LIGHT3);
        cell->resetHints();
      }
    }//clean up existing cells
    
    //parse the first line of the file
  	//get the puzzle
    if (! myfile.eof() )
    {
      myfile.getline (line,MAXLINESIZE);    
      
      //printf("input string =%s\n", line);
      index = 0;
      for (int ii=0; ii<9;ii++)
      {
     	for (int jj=0;jj<9;jj++)
    	{
    	  int value =  line[index] - '0';
    	  //printf("input [%d] = %c = (%d)\n", index, line[index], value);

	  	  tempcell = s->grid_cells_[ii][jj];
	 
	  	  if ( value > 0 && value <= 9 )
	  	  {
	  	    tempcell->readonlySet(1);
	  	    tempcell->valueSet(value);	  	    
        	tempcell->color(FL_GRAY);
	  	  }  
	  	  index++;
 		}// for jj 		
      }//for ii
    }//not eof
   
    // get user values and hints if they are available
    index = 0;
    bool hasHints = false;
    
    while (! myfile.eof() && index < 81)
    {
   	  myfile.getline (line,MAXLINESIZE);    
      //printf("(%d)input string =%s\n", index, line);
      //typical line format with value: 0,5:9      //i,j:value
      //typical line format with hints: 5,2:02458  //i,j:0hints
      i = line[0] - '0';
      j = line[2] - '0';
      //printf("cel (%d,%d) has {%s}  =>  ", i,j, line);
      tempcell = s->grid_cells_[i][j];
      
      int value = line[4] - '0';
      if (value != 0)
      {
      	//if not a puzzle value set the user value
      	if (!tempcell->readonlyGet())
      	{ 
      	  tempcell->valueSet(value);	  
          //printf("USER value = %d\n",value);
      	}
      	else
      	{
     	  //printf("PUZZLE value = %d\n", value);     	  
      	}
      }
      else
      {
        //printf("HINTS = ");
        int linesize = strlen ( line );
     	  if (linesize >= 5)
     	  {
		      for (int teller = 5; teller < linesize; teller++)
		      {
		      	if (!hasHints) hasHints=true;
		      	value = line[teller]-'0';
		      	//printf(" %d, ",value);
		      	tempcell->test_valueSet(value, DUMMY);
		      }
     	  }
          //printf("\n");
      }
      index++;
    }
  
    myfile.close();
    
    //set prefs_ to imported
    s->hassolution_ = 0;
    prefs_.set("hassolution", s->hassolution_);  
  }
  else
  {
  	 cout << "Unable to open file (" << filename << ")\n"; 
  }
}// loadstatus_cb

void
Sudoku::hassound_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int hassound = ((Fl_Menu_ *)widget)->mvalue()->value() ==  FL_MENU_VALUE;
  
  if (hassound != s->hassound_) 
  {
    s->hassound_ = hassound;
    prefs_.set("hassound", s->hassound_);
    s->sound_->soundon(hassound);
  }
}// hassound_cb

void
Sudoku::autohints_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int autohints = ((Fl_Menu_ *)widget)->mvalue()->value() ==  FL_MENU_VALUE;
  
  //printf("autohints_cb old[%d]  new[%d]\n",s->autohints_, autohints);
  if (autohints != s->autohints_) 
  {
    s->autohints_ = autohints;
    prefs_.set("autohints", s->autohints_);
  }
}// autohints_cb

void
Sudoku::autounique_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int autounique = ((Fl_Menu_ *)widget)->mvalue()->value() ==  FL_MENU_VALUE;
  
  //printf("autounique_cb old[%d]  new[%d]\n",s->autounique_, autounique);
  if (autounique != s->autounique_) 
  {
    s->autounique_ = autounique;
    prefs_.set("autounique", s->autounique_);
  }
}// autounique_cb

void
Sudoku::autopromoteunique_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int promoteunique = ((Fl_Menu_ *)widget)->mvalue()->value() ==  FL_MENU_VALUE;
  
  //printf("promoteunique_cb old[%d]  new[%d]\n",s->promoteunique_, promoteunique);
  if (promoteunique != s->promoteunique_) 
  {
    s->promoteunique_ = promoteunique;
    prefs_.set("promoteunique", s->promoteunique_);
  }
}//autopromoteunique_cb

void
Sudoku::hints_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  
  s->hints();
}// hints_cb

void
Sudoku::hints()
{
 //start looping the grid
  for (int i = 0; i < 9; i ++)
  {
    for (int j = 0; j < 9; j ++) 
    { 
      //get the cell
      SudokuCell *cell = grid_cells_[i][j];
      
      if( !cell->valueGet() )
      {
		for(int hints=1; hints<=9; hints++)
		  cell->test_valueSet(hints,DUMMY);
	      
	    for(int k=0; k<9; k++) /* 9 values in row, column and block */
	    {
	      for( int v=1; v<=9; v++)
	      {
	        if( grid_cells_[k][j]->valueGet()                           == v ||
	            grid_cells_[i][k]->valueGet()                           == v ||
	            grid_cells_[(i/3)*3 + (k%3)][(j/3)*3 + k/3]->valueGet() == v
	           )
	        {
	       	  cell->hintsRemove(v);
	        }
	      }
	    }
      }
    }
  }//end loop	
}//hints()

void
Sudoku::removehints_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  
  s->removehints();
}// removehints_cb

void
Sudoku::removehints()
{
  SudokuCell *cell;
  
 //start looping the grid
  for (int i = 0; i < 9; i ++)
  {
    for (int j = 0; j < 9; j ++) 
    { 
      //get the cell
      cell = grid_cells_[i][j];
      
      if( !cell->valueGet() )
      {
		for(int hint=1; hint<=9; hint++)
		  cell->hintsRemove(hint);
      }
    }
  }//end loop
  
  //cleanup the uniquehints grid
  // - remove unique hint values
  // - remove tempcell->color(FL_MAGENTA);
   
  for (int i=0; i<9;i++)
  	for (int j=0;j<9;j++)
  	{
  		cell = grid_cells_[i][j];
  		if (cell->uniquehintGet())
  		{
    		cell->uniquehintSet(0);
    		cell->color(FL_LIGHT3);
  		}  		
  	}	
}//removehints

void
Sudoku::hintthis_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int i = s->lastFocusI;
  int j = s->lastFocusJ;
  s->hintthiscell(i,j);
}//hintthis_cb

void
Sudoku::hintthiscell(int i, int j)
{
  //get the cell
  SudokuCell *cell = grid_cells_[i][j];
  //printf("hintsthiscell [%d,%d]\n", i, j);

  if( !cell->valueGet() )//only empty cells
  {
  	//initally everything is possible
	for(int hints=1; hints<=9; hints++)
	  cell->test_valueSet(hints,DUMMY);
	      
	for(int k=0; k<9; k++) /* 9 values in row, column and block */
	{
	  for( int v=1; v<=9; v++)
	  {
	    if( grid_cells_[k][j]->valueGet()                           == v ||
	        grid_cells_[i][k]->valueGet()                           == v ||
	        grid_cells_[(i/3)*3 + (k%3)][(j/3)*3 + k/3]->valueGet() == v
	        )
	    {
	      cell->hintsRemove(v);
	    }
	  }//v loop for all values
    }//k loop iterator within row/col/box
  }//do open cells only 
}//hintthiscell

void
Sudoku::updatehintsfromthis_cb(Fl_Widget *widget, void *)
{
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int i = s->lastFocusI;
  int j = s->lastFocusJ;
  s-> updatehintsfromthis(i,j);
}//updatehintsfromthis_cb

void
Sudoku::updatehintsfromthis(int i, int j)
{
  // loop rows and column and box to remove this value
  
  //get the cell
  SudokuCell *cell = grid_cells_[i][j];
  SudokuCell *tempcell;
  
  int v = cell->valueGet();
  //printf("updatehintsfromthis [%d,%d] = %d\n", i, j, v);
  if( v )//only user filed in 
  {
	for(int k=0; k<9; k++) // walk values in row, column and box
	{
	  //row	
	  tempcell = grid_cells_[k][j];
	  tempcell->hintsRemove(v);
	  //column
	  tempcell = grid_cells_[i][k];
  	  tempcell->hintsRemove(v);
	  //box
	  tempcell = grid_cells_[(i/3)*3 + (k%3)][(j/3)*3 + k/3];
  	  tempcell->hintsRemove(v);
	 	  
    }//k loop iterator within row/col/box
  }//do open cells only 
}//updatehintsfromthis

void
Sudoku::showthisvalue_cb(Fl_Widget *widget, void *)
{ 
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);
  int i = s->lastFocusI;
  int j = s->lastFocusJ;
  s-> showthisvalue(i,j);
}//showthisvalue_cb

void
Sudoku::showthisvalue(int i, int j)
{
  // highlight all cells with this value
  
  //get the cell
  SudokuCell *cell = grid_cells_[i][j];
  SudokuCell *tempcell;
  
  int value = cell->valueGet();

  if( value )//only filled in 
  {

	//loop grid
	for(int i=0; i<9; i++) 
	{
	  for(int j=0; j<9; j++) 
	  {
         tempcell = grid_cells_[i][j];
         if ( tempcell->valueGet() == value)
         {
           tempcell->color(FL_MAGENTA);
         }//found a match
         else
         { // remove highlight of previous value
           if (tempcell->color() == FL_MAGENTA)	
           {
	           if ( tempcell->readonlyGet())
	           {
	             tempcell->color(FL_GRAY);
	           }//found a match
	           else
	           {
		         tempcell->color(FL_LIGHT3);
	           }
           }
         }
	  }//j
    }//i

  }//do open cells only 
  redraw();
}//showthisvalue

void
Sudoku::cleanBackgrounds()
{
  SudokuCell *tempcell;
  //loop grid
  for(int i=0; i<9; i++) 
  {
	for(int j=0; j<9; j++) 
	{
      tempcell = grid_cells_[i][j];
      if ( tempcell->readonlyGet())
      {
        tempcell->color(FL_GRAY);
      }//found a match
      else
      {
	    tempcell->color(FL_LIGHT3);
      }
      if (tempcell->uniquehintGet())
      {
    	tempcell->uniquehintSet(0);
      }
    }//j
  }//i
  redraw();
}//cleanBackgrounds
  
void
Sudoku::showuniquehints_cb(Fl_Widget *widget, void *)
{
  // loop rows and column and box to remove this value
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);  
  s->showuniquehints();
  if (s->getpromoteunique()) s->promoteuniquehints();
  s->redraw();
}//showuniquehints_cb
 
void
Sudoku::showuniquehints()
{	
  //search all rows, columns and boxs for unique hints-> highlight box and hint nr
  //originally only look within the hints now also include the values given 
  SudokuCell *tempcell;
  
  //cleanup the grid first
  // - remove unique hint values
  // - remove tempcell->color(FL_MAGENTA);
   
  for (int i=0; i<9;i++)
  	for (int j=0;j<9;j++)
  	{
  		tempcell = grid_cells_[i][j];
  		if (tempcell->uniquehintGet())
  		{
    		tempcell->uniquehintSet(0);
    		tempcell->color(FL_LIGHT3);
  		}  		
  	}
  	
  //[which row][hint], value = -1 not found yet, value [0,8] first cell with this hint, 
  //-2: more than one hint
  int row[9][10]; //[z][hints]; only use hints 1-9
  int col[9][10];
  int box[9][10];
  
  //int cellH[9][9];//[I][J], value = unique cell hint
  
  //init :)
  memset(row, -1, sizeof(row));
  memset(col, -1, sizeof(col));
  memset(box, -1, sizeof(box));
  memset(cellHint, -1, sizeof(cellHint));
     
  for (int  z=0; z<9; z++) // loop over all row, column and boxes 
  {
	//loop trough col/row/boxes => collect data
	for (int  k=0; k<9; k++) // walk values in row, column and box
	{
      //printf("k(%d)\n", k);
      //row	
	  tempcell = grid_cells_[z][k];
	  testcell(tempcell, row[z], k);
  
      //column
 	  tempcell = grid_cells_[k][z];
	  testcell(tempcell, col[z], k);
	  
	  //box
	  tempcell = grid_cells_[(z/3)*3 + (k%3)][(z%3)*3 + k/3];
  	  testcell(tempcell, box[z], k);
  	  
  	  //cellH already undated 3 times by testcell in the row/col/box loops
    }
  }
  
  //loop through collected data and process the data
  for (int z=0; z<9; z++) // loop over all row, column and boxes 
  {
  	for (int k=1; k<=9; k++) // /loop trough col/row/boxes : inspect uniques
  	{
  		//if value then found unique in this row/col/box print it :)
  		//ROWS
  		int rowindex = row[z][k];
  		if (rowindex>= 0)  //!-1 & !-2
  		{
  			//found a unique in this row
  			//printf("row[%d] = cell(%d,%d) hint value %d\n",z, z, rowindex, k);
  			tempcell = grid_cells_[z][rowindex];
  			tempcell->uniquehintSet(k);
  			tempcell->color(FL_CYAN);
   		}
  		
  		//COLUMNS
  		int colindex = col[z][k];
  		if (colindex>= 0)  //!-1 & !-2
  		{
  			//found a unique in this row
  			//printf("col[%d] = cell(%d,%d) hint value %d\n",z, colindex, z, k);
  			tempcell = grid_cells_[colindex][z];
  			tempcell->uniquehintSet(k);
  			tempcell->color(FL_CYAN);
  		}
  		  		
  		//BOXES
  		int boxindex = box[z][k];
  		if (boxindex>= 0)  //!-1 & !-2
  		{
  			//found a unique in this row
  			//printf("box[%d] = cell(%d,%d) hint value %d\n",z, (z/3)*3 + (boxindex%3),(z%3)*3 + boxindex/3, k);
  			tempcell = grid_cells_[(z/3)*3 + (boxindex%3)][(z%3)*3 + boxindex/3];
  			tempcell->uniquehintSet(k);
  			tempcell->color(FL_CYAN);
  		}
  		//CELL HINTS
  		int singlehint = cellHint[z][k-1];
  		if (singlehint > 0)  //!-1 & !-2
  		{
  			//found a unique in this row
  			//printf("col[%d] = cell(%d,%d) hint value %d\n",z, colindex, z, k);
  			tempcell = grid_cells_[z][k-1];
  			tempcell->uniquehintSet(singlehint);
  			tempcell->color(FL_CYAN);
  		}
  	}
  }
}//showuniquehints
 
void Sudoku::printHints(int *hints)
{
	printf("hints =[");
	for (int i = 0; i<9 ; i++)
	{
	   printf("%d, ", hints[i]);
	}
	printf("]\n");
} // printHints array

void Sudoku::testcell(SudokuCell * cell, int* hints, int index)
{
    int hintvalue;
	//printHints(hints);
	if (!cell->valueGet() ) //look at the hints
	{
		//no value look at the hints
		//printf("cell (%d,%d):\n", cell->myI, cell->myJ);
		
		//cellH bookkeeping
		int singleHint	= 0; //0 not one yet, 1 - 9 the hint found, 10 more than one hint
		
		//loop all 9 hints
		for (int h=1;h<=9;h++)
		{
			hintvalue = cell->hintsGet(h);  //[0,9] filled 1-9

			if (hintvalue) //found hint h in this cell : bookkeep
			{
				//printf("found hint(%d) at cell (%d,%d), index (%d)\n", h, cell->myI, cell->myJ, index);
				if (!singleHint) 
					singleHint = hintvalue;
				else
					if (singleHint < 10) singleHint = 10;
				
				int currentKept = hints[h];
				if (currentKept == -1)//not yet registered 
				{
					//none yet
					hints[h] = index; //[1,9]
   			        //printf("first time found hint(%d) in row/col/box {cell (%d,%d)}\n", h, cell->myI, cell->myJ);
				}
				else if (currentKept >= 0)
				{
				   //already one exists
				   //printf("already exist hint(%d) in row/col/box {cell (%d,%d)}\n", h, cell->myI, cell->myJ);
				
	               hints[h] = -2;
				} else 
				{
					//more than one exists curentKept should be -2				
				}
			}// there is a hint in this cell
			else
			{
				//no hintvalue
			}
     		//printf("    hint (%d) = %d\n", h,hintvalue);
		}//h loop hints
		if (singleHint > 0 && singleHint < 10)
		{
			//a single hint is found and thus unique for this cell instead for a row or column :)
			cellHint[cell->myI][cell->myJ] = singleHint;
			//printf("cell (%d,%d) has single hint [%d]\n", cell->myI, cell->myJ, singleHint);
		}
	}//only look at empty cells
	else
	{
		//values exist use value()	
		//printf("cell (%d,%d) has value %d\n", cell->myI, cell->myJ, cell->value());
	}
}//testcell

void
Sudoku::promoteunique_cb(Fl_Widget *widget, void *)
{
  // loop rows and column and box to remove this value
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);  
  s->promoteuniquehints();
  s->redraw();
  
}//promoteunique_cb

void
Sudoku::promoteuniquehints()
{	
	//printf("promoteuniquehints\n");
	//search all rows, columns and boxs for unique hints-> highlight box and hint nr
   
  SudokuCell *tempcell;
  
  //find all uniqueHints and promote this hint to value, 
  //and cleanup the unique admin
  // - remove unique hint values
  // - remove tempcell->color(FL_MAGENTA);
   
  for (int i=0; i<9;i++)
  {
  	for (int j=0;j<9;j++)
  	{
  		tempcell = grid_cells_[i][j];
  		
  		if ((tempcell->uniquehintGet()) )//&& 
//  		    (!tempcell->value()) && 
  //		    (!tempcell->readonly())
  		{
    		tempcell->valueSet(tempcell->uniquehintGet());
    		tempcell->uniquehintSet(0);
    		tempcell->color(FL_LIGHT3);

    		if (autohints_) updatehintsfromthis(i, j);
  		}  		
  	}
  }
  //do undate hints
  
}//promoteuniquehints

void
Sudoku::setFocusCell(int I,int J)
{
	lastFocusI = I;
	lastFocusJ = J;	
	//printf("focus cell=(%d,%d)\n",lastFocusI,lastFocusJ);
}

int   
Sudoku::getautohints()
{
	return autohints_;
}

int   
Sudoku::getautounique()
{
	return autounique_;
}

int   
Sudoku::getpromoteunique()
{
	return promoteunique_;
}

void
Sudoku::helpme_cb(Fl_Widget *widget, void *)
{
  // if hassolution_ is true, pick random a open cell and show its solution value
  // advance highlight it ?green? -> update remove highlight routines  
  // Sudoku::cleanBackgrounds()
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);  
  s->helpme();
  s->redraw();
  
}//helpme_cb

void
Sudoku::helpme()
{
		
}//helpme
	
void
Sudoku::NumberOfSolutions_cb(Fl_Widget *widget, void *)
{
  // calulate the number of solutions give the current
  // game (puzzle as well as user values)
  // use backtracking
  Sudoku *s = (Sudoku *)(widget->window() ? widget->window() : widget);  
  s->numberOfSolutions();
  s->redraw();
  
}//solutions_cb

void
Sudoku::numberOfSolutions()
{
	SudokuCell *tempcell;
	int solutions = 0; //resulted number of solutions
	int hint;  //temp value for hints
	time_t starttime;
    time_t endtime;
    solvechecks = 0;
    
    starttime = time (NULL);
	//first clone the game (puzzle values & user values) into a backtracking grid. 	
	//char startGrid[9][9][10];  
	              // i  j       values; 
	              //       [0] the actual value, 
	              //       [1.9] hints,
	              //       [10] bool 1: value / 0: hints
	memset(testGrid, 0, sizeof(testGrid));
	
	// fill with values
	for (int i = 0; i<9; i++)
	{
		for (int j = 0; j<9; j++)
		{
			tempcell = grid_cells_[i][j];
		    testGrid[i][j][0] = tempcell->valueGet();
   		    if (testGrid[i][j][0]) testGrid[i][j][10] = 1; //1: value 0: hints
   		    //startGrid[i][j][10] = startGrid[i][j][0]; //1..9: value / 0: hints
		}
	}
		
    // and find all possible hints ( copied from hints() )
    for (int i = 0; i < 9; i ++)
    {
      for (int j = 0; j < 9; j ++) 
      {        	
         if( !testGrid[i][j][10] ) //not a value 
         {         	
         	// init all hint values as beeing available
	    	for(hint=1; hint<=9; hint++)
		      testGrid[i][j][hint]= hint;
	      
	        //remove hints that are in row/col/box
	        for(int k=0; k<9; k++) /* 9 values in row, column and block */
	        {
	          for( int h=1; h<=9; h++)
	          {
	            if( testGrid[k][j][0]                           == h ||
	                testGrid[i][k][0]                           == h ||
	                testGrid[(i/3)*3 + (k%3)][(j/3)*3 + k/3][0] == h
	              )
	            {
	       	      testGrid[i][j][h]= 0; //remove the hint
	            }
	          }//h
	        }//k
          }//if no value do the hints :)
        }//j
     }//i: end loop	
   
   	   
	//start backtracking (over all hints) untill all hints covered
    solutionsStopped = false;  //break off at 2nd solution
	solveGrid( 0, &solutions);

    endtime = time (NULL);
    long deltatime = endtime - starttime;
    int hours = deltatime / 3600;
    int min = deltatime / 60;
    int sec = deltatime % 60;
	//if solutions = 1 OK, >1 multiple solutions, 0 user made a mistake
    char msgbuf [255];
    if (solutions ==1)
    {
      //printf("There are [%d] solutions!\n", solutions);		
      
      sprintf(msgbuf,"This is a REAL Sudoku, there is a SINGLE solution!\n Time spend solving= %d:%02d:%02d", hours,  min, sec );
    }
    else if (solutions > 1)
    {
      sprintf(msgbuf,"NOT a real sudoku, there are at least %d solutions ;(\nTime spend solving= %d:%02d:%02d", solutions, hours, min, sec );
    }
    else //if (solutions ==0)
    {
      sprintf(msgbuf,"NO Solution Exists! ;(\nTime spend solving= %d:%02d:%02d", hours, min, sec );
    }
    
    //printf("MESSAGE=%s",msgbuf);    
    fl_message(msgbuf);
    
	//advanced -> if (!hassolution_)  copy the solution into the current game
}//solutions
	
void
Sudoku::solveGrid(int startValue, int* solutionsPtr)
{
	//printf("solveGrid(%d, %d)\n", startValue, *solutionsPtr);	
	if (startValue == 81) //solved (0-80) dus alles is ingevuld neem ik aan
	{
  	  //check the filled in version with the check routine.
  	  if (checkGrid())
  	  {   	  	
  	  	*solutionsPtr = *solutionsPtr + 1;
  	  	printf("Solution [%d]: ", *solutionsPtr); printGrid();
  	  	if (*solutionsPtr == 2)  //or 5 or ...
  	  	{
  	  	  solutionsStopped = true;
  	  	}
  	  }
	}
	else
	{
		int i = startValue / 9;
        int j = startValue % 9;
        
        if (j==0) // or   startValue % ANYVALUE
        {        	
        	if (!checkGrid())
        	{
        		//printf("Illegal partial sudoku at (%d,%d)\n", i,j);	
        		return; //wrong path
        	} 
        }
        
        if (!testGrid[i][j][10])
        {
          // has hints
       	  //printf("HAShints in (%d,%d)\n", i,j);	
       	   
       	  //foreach hint in this cell do as value
          for (int h=1; h<10 && !solutionsStopped; h++)
          { 
        	if (testGrid[i][j][h]) 
        	{
        	  testGrid[i][j][0] = h;
        	  //printf("choose (%d,%d) => %d\n", i,j ,h);	
        	  //printf("HINTS => value  ");	
        	  //printGridcell(i,j);
        	  solveGrid (startValue+1, solutionsPtr);
        	}
          }
          testGrid[i][j][0] = 0;        	
        }
        else
        {
        	// has no hints
        	solveGrid(startValue+1, solutionsPtr);
        }
	}//check or continue
}// solveGrid	

int Sudoku::checkGrid()
{
  //if empty cells don't care
  	
  solvechecks++;	
  if( solvechecks%10000==0 ) printf("%ld checkGrid\n", solvechecks );
  //printf("%ld checkGrid\n", solvechecks );
  int result = 0; // 1: OK 0: wrong
	
  //bool empty = false;
  bool correct = true;
  
  int i, j, k;

  // Check the game for right/wrong answers...
  for (i = 0; i < 9; i ++)
    for (j = 0; j < 9; j ++) 
    {
      int val = testGrid[i][j][0];
      
      if (val) 
      {
        for (k = 0; k < 9; k ++)
          if ((i != k && testGrid[k][j][0] == val) ||
	      (j != k && testGrid[i][k][0] == val))
	      {
	      	//if (i != k && startGrid[k][j][0] == val)
		    //  	printf("value[%d] at (%d,%d) = (%d,%d)  col\n", val, i,j, k,j); 
		    //if (j != k && startGrid[i][k][0] == val)
	      	//  	printf("value[%d] at (%d,%d) = (%d,%d) row\n", val, i,j, i, k); 
	      	break;
	      }

        if (k < 9) 
        {
          correct = false;
	    } 
      }
    }

  // Check subgrids for duplicate numbers...
  for (i = 0; i < 9; i += 3)
    for (j = 0; j < 9; j += 3)
      for (int ii = 0; ii < 3; ii ++)
        for (int jj = 0; jj < 3; jj ++) 
        {
          int val = testGrid[i + ii][j + jj][0];

          if (testGrid[i + ii][j + jj][10] || !val) continue;

          int iii;

          for (iii = 0; iii < 3; iii ++) 
          {
            int jjj;

            for (jjj = 0; jjj < 3; jjj ++)
              if (ii != iii && jj != jjj &&
              testGrid[i + iii][j + jjj][0] == val)
              { 
              	 //What went wrong here?? printf("something wrong in subgrid\n");
              	 break;
              }
              
            if (jjj < 3) break;
	      }

          if (iii < 3) 
          {            
            correct = false;
	      }
	    }
        //if (!empty && correct) 
        if ( correct) 
        {
          // Success!  
          result = 1; // 1: OK 0: wrong
        }
        return result;
}//Sudoku::checkGrid()

void
Sudoku::printGrid()
{
  for (int i=0; i<9;i++)
	for (int j=0;j<9;j++)
	{
  		printf("%d", testGrid[i][j][0] );
 	}	
  printf("\n");
}//printGrid

void
Sudoku::printGridcell(int printi, int printj)
{
   printf("CELL (%d,%d):",printi,printj);
    for( int i=0; i<=10; i++)
	{
	   printf("%d, ",testGrid[printi][printj][i] );
	}
	printf(";\n");
}
//===================================================================
//===================================================================
// Main entry for game...
int
main(int argc, char *argv[]) {
  Sudoku s;

  // Show the game...
  s.show(argc, argv);


  // Load the previous game...
  s.load_pref_game();

  // Run until the user quits...
  return (Fl::run());
}


//
// End of "$Id: sudoku.cxx 4744 2006-01-13 22:46:30Z mike $".
//
